<!DOCTYPE html>
<html>

<head>
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta name="mobile-web-app-capable" content="yes">

	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, user-scalable=no">
	<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
	<meta charset="UTF-8">
	<title>Open Banking Brasil Functional Conformance: Test Plan</title>

	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

	<!-- Optional theme -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">
	<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=PT+Sans">
	<link rel="stylesheet" type="text/css" href="css/layout.css">

	<!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
	<!-- Latest compiled and minified JavaScript -->
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>

	<script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.11/lodash.js" integrity="sha256-vS9J2VYhvwAfh2znnLdkhemFPEpx6YoZEhExqBPT5ys=" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.0/clipboard.min.js"></script>

	<script type="text/javascript" src="js/fapi.ui.js"></script>
</head>

<body>

	<div class="pageHeader container-fluid">
		<div class="row-fluid">
			<div class="col-md-8">
				<a href="index.html"><img src="/images/ob_brasil.svg"></a>
			</div>
			<div id="userInfoHolder" class="col-md-4 text-right"></div>
		</div>
	</div>
	<div class="clearfix"></div>

	<!-- error modal -->
	<div class="modal fade" id="errorModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
					<h4 class="modal-title" id="errorLabel">Error</h4>
				</div>
				<div class="modal-body">
					Error: <span id="errorMessage"></span>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				</div>
			</div>
		</div>
	</div>

	<!-- loading modal -->
	<div class="modal fade" id="loadingModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel" data-backdrop="static" data-keyboard="false">
		<div class="modal-dialog modal-sm" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h4 class="modal-title" id="loadingLabel">Loading...</h4>
				</div>
				<div class="modal-body">
					<div class="text-center">
						<img src="/images/spinner.gif" width="100px" height="30px" />
					</div>
					<div>
						<span id="loadingMessage"></span>
					</div>
				</div>
			</div>
		</div>
	</div>

	<!-- Config modal popup -->
	<div class="modal fade" id="configModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
		<div class="modal-dialog modal-lg" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
					<h4 class="modal-title">
						<button class="btn-clipboard btn btn-xs" data-clipboard-target="#config" alt="Copy config to clipboard" title="Copy config to clipboard"><span class="glyphicon glyphicon-copy"></span></button>
						Configuration for <code id="configTestId" class="text-muted"></code>
					</h4>
				</div>
				<div class="modal-body">
					<div class="wrapLongStrings">
						<pre id="config"></pre>
					</div>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				</div>
			</div>
		</div>
	</div>

	<!-- Publish modal -->
	<div class="modal fade" id="publishModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
					<h4 class="modal-title" id="errorLabel">Publish</h4>
				</div>
				<div class="modal-body">
					Are you sure? This will make all keys, secrets, and all other test information publicly visible.
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-default" data-dismiss="modal" data-publish="everything">Publish</button>
					<button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
				</div>
			</div>
		</div>
	</div>
    <!-- Certification submission modal -->
    <div class="modal fade" id="certificationPackageModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title" id="errorLabel">Prepare Certification Submission Package</h4>
                </div>
                <form class="form" name="certificationPackageForm" id="certificationPackageForm" action="" method="post" enctype="multipart/form-data" >
                <div class="modal-body">
                    <div id="certificationPackageFormErrors"></div>
                    Clicking the &quot;Prepare Certification Package&quot; button will trigger the following:
                    <ol>
                        <li>The test plan will be published (This will make all keys, secrets, and all other test information publicly visible.)</li>
                        <li>The test plan will be marked as immutable.
                            <b class="text-warning">
                                You will not be able to run tests under this plan, once you click the Prepare Certification Package button.
                            </b>
                        </li>
                        <li>
                            A zip file containing your certification submission package will be downloaded to your computer.
                            Please follow <a href="https://gitlab.com/obb1/certification/-/wikis/Certification-Guide" target="_blank">submission instructions</a>
                            to complete the certification process.
                        </li>
                    </ol>
                    <b class="text-info">Upload files to be included the package:</b>
                    <div style="margin-left:2em; margin-right:2em;">
                        <div class="form-group">
                                <fieldset>
                                    <label class="text-success">
                                        Termos-e-condições.pdf
                                    </label>
                                    <input type="file" id="termsAndConditionsPdfBtn" name="termsAndConditionsPdf" accept="application/pdf">
                                    <p class="help-block">Upload the file as is.</p>
                                </fieldset>
                        </div>
                        <div class="form-group">
                                <fieldset>
                                    <label class="text-success">
                                        Certificado-de-conformidade-funcional.pdf
                                    </label>
                                    <input type="file" id="certificationOfConformancePdfBtn" name="certificationOfConformancePdf" accept="application/pdf">
                                    <p class="help-block">Upload the signed certification of conformance file
                                        (i.e as per the instructions, completed and signed by an authorized person).
                                    </p>
                                </fieldset>
                        </div>
                        <div class="form-group">
                            <fieldset>
                                <label class="text-success">
                                    Client Data (For RP Tests Only)
                                </label>
                                <input type="file" id="clientSideDataBtn" name="clientSideData" accept="application/zip">
                                <p class="help-block">Client side logs and similar additional data. Only needed for RP tests. Must be a zip file.</p>
                            </fieldset>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button id="certificationPackageFormSubmitBtn" type="submit" class="btn btn-primary">Prepare Certification Package</button>
                    <div style="display:none" id="certificationPackageFormRefreshNotice">Please refresh the page after the download is completed</div>
                </div>
                </form>
            </div>
        </div>
    </div>

    <!-- Prepare certification of conformance pdf modal -->
    <div class="modal fade" id="certificationOfConformanceTemplateModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title" id="errorLabel">Prepare Certification of Conformance PDF</h4>

                </div>
                <form class="form-small" name="certificationOfConformanceForm" id="certificationOfConformanceForm" action="" method="post">
                    <div class="modal-body">
                        <div id="certificationOfConformanceFormErrors"></div>
                        <div class="text-info">
                            This page will help you prepare the PDF you will upload after pressing the 'Certification Package' button.
                            Once you have generated the PDF you will need to sign it (electronic signatures are preferred).
                            See <a href="https://openid.net/certification/instructions/" target="_blank">the submission instructions</a> for more information.
                            <br>
                            You will be able to edit the document after downloading, you don't need to fill all fields now.
                            This form is provided for your convenience only, and its use is optional.
                        </div>
                        <div>
                            <div>
                                <h3 style="border-bottom:1px solid #eee;">
                                    Required Information
                                </h3>
                                <div style="padding-left:1em;">

                                    <div class="form-group">
                                        <label>
                                            Name of Entity (“Implementer”) Making this Certification
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_nameOfImplementer" name="nameOfImplementer">
                                    </div>
                                    <div class="form-group">
                                        <label>
                                            Software or Service (&quot;Deployment&quot;) Name &amp; Version #
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_deploymentVersion" name="deploymentVersion">
                                    </div>
                                    <div class="form-group">
                                        <label>
                                            OpenID Conformance Profile
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_conformanceProfile" name="conformanceProfile" readonly>
                                    </div>
                                    <div class="form-group">
                                        <label>
                                            Conformance Test Suite Software
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_suiteSoftware" name="suiteSoftware" readonly>
                                    </div>
                                    <div class="form-group">
                                        <label>
                                            Test Date
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_testDate" name="testDate" readonly>
                                    </div>
                                </div>
                            </div>
                            <div>
                                <h3 style="border-bottom:1px solid #eee;">
                                    Optional Extra Information
                                </h3>
                                <div style="padding-left:1em;">
                                    <div class="form-group">
                                        <label>
                                            URL at which people interested in using your implementation can learn about it and/or obtain it:
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_moreInfoUrl" name="moreInfoUrl">
                                    </div>
                                    <div class="form-group">
                                        <label>
                                            1-2 sentence description of the implementation
                                        </label>
                                        <textarea class="form-control" type="text" id="certificationOfConformance_implementationDescription" name="implementationDescription"></textarea>
                                    </div>
                                    <div class="form-group">
                                        <label>
                                            The programming language of the software and deployment environment for it, if applicable (e.g., “JavaScript for Node.js”, “Binaries for iOS”, or “Service”)
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_programmingLanguage" name="programmingLanguage">
                                    </div>
                                    <div class="form-group">
                                        <label>
                                            Licensing terms of the software, if applicable (e.g., “Apache 2.0” or “Proprietary”)
                                        </label>
                                        <input class="form-control" type="text" id="certificationOfConformance_license" name="license">
                                    </div>
                                </div>
                            </div>

                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button id="certificationOfConformanceFormSubmitBtn" type="submit" class="btn btn-primary">Download as PDF</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <!-- Rerun test confirmation modal -->
    <div class="modal fade" id="reRunTestModal" tabindex="-1" role="dialog" aria-labelledby="errorLabel">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    <h4 class="modal-title">Run test confirmation</h4>
                </div>
                <div class="modal-body">
                    Are you sure you want to rerun this test? It is owned by a different user.
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" data-dismiss="modal" id="reRunTestModalBtn">Sure, Run it</button>
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>

    <!-- resident DOM -->
    <div class="container-fluid">
        <div id="planDetail">
            <div class="header"></div>
            <div class="content container-fluid">
                <!-- main page is rendered here -->
            </div>
        </div>
    </div>

    <script type="text/javascript">

       function getPlan(planId, public) {
           return $.ajax({
               type: 'GET',
               url: '/api/plan/' + encodeURIComponent(planId) + (public ? '?public=true' : ''),
               data: {},
               success: function(data) {
                   $('#certificationPackageForm').attr('action','/api/plan/'+planId+'/certificationpackage');
				   $('.content').append(FAPI_UI.logTemplates.PLAN_START({ plan: data, public: public, variant: FAPI_UI.formatVariant(data.variant) }));

                   $('#downloadAllBtn').click(function(evt) {
                       evt.preventDefault();
                       window.open('/api/plan/exporthtml/' + encodeURIComponent(planId) + (public ? '?public=true' : ''));
                   });

				   // wire up configuration button
                   $('#showConfigBtn').click(function(evt) {
                       evt.preventDefault();
                       $('#config').html(_.escape(JSON.stringify(data.config, null, 4)));
                       $('#configTestId').html(_.escape(planId));
                       $('#configModal').modal('show');
                   });

				   // wire up publish button
				   $('#publishBtn').click(function(evt) {
					   evt.preventDefault();
					   $('#publishModal').modal('show');
				   });

				   $('#certificationPackageBtn').click(function(evt) {
					   evt.preventDefault();
					   $('#certificationPackageModal').modal('show');
				   });

                   $('#certificationOfConformanceTemplateBtn').click(function(evt) {
                       evt.preventDefault();
                       $('#certificationOfConformanceTemplateModal').modal('show');
                   });
                   $('#certificationOfConformanceForm').attr('action','/api/plan/'+planId+'/certificationofconformance');
                   $('#certificationOfConformance_conformanceProfile').val(data.certificationProfileName);
                   $('#certificationOfConformance_suiteSoftware').val('www.certification.openid.net version ' + data.version);
                   $('#certificationOfConformance_testDate').val(data.started?data.started.substring(0,10):'');

                   $('[data-module]').click(function(evt) {
                       evt.preventDefault();
					   var testName = $(this).data('module');
					   var variant = $(this).data('variant')
					   if(FAPI_UI.currentUser.sub !== data.owner.sub){
						   $('#reRunTestModalBtn').data('test-name', testName);
						   $('#reRunTestModalBtn').data('variant', variant);
						   $('#reRunTestModal').modal('show');
					   } else {
						   runTest(testName, variant, planId);
					   }
				   });

				   $('[data-instance-id]').each(function() {
                      var _self = $(this);

					  var testId = _self.data('instanceId');

					  if (testId) {
						  // wire up the download button
                          $('.downloadBtn', _self).click(function(evt) {
                              evt.preventDefault();
                              window.open('/api/log/export/' + encodeURIComponent(testId) + (public ? '?public=true' : ''));
                          });
                          $('.downloadBtn', _self).show();
                          // show the view button
                          $('.viewBtn', _self).css('display', 'inline-block');
                          // fetch the test status
                          console.log('Fetching |' + testId + '|');
	                      $.ajax({
	                          type: 'GET',
	                          url: '/api/info/' + encodeURIComponent(testId) + (public ? '?public=true' : ''),
	                          data: {},
	                          success: function(data) {
	                              $('.testStatusAndResult', _self).html(FAPI_UI.logTemplates.TEST_STATUS({test: data}));
	                              $('.testVersion', _self).html(FAPI_UI.logTemplates.TEST_VERSION({testVersion: data.version}));
                                  FAPI_UI.activeTooltip();
                              },
	                          error: function(jqxhr, status, error) {
	                              if (jqxhr.status == 404) {
	                                  // If the latest run is not accessible (an admin has re-run the test or it's unpublished),
	                                  // we won't be able to fetch the status (error 404).
	                                  // Just ignore it.
	                              } else {
	                                  FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
	                                      code: jqxhr.status,
	                                      error: error
	                                  });
	                              }
	                          }
	                      });
					  } else {
						  // render an "UNKNOWN" field
                          $('.testStatusAndResult', _self).html(FAPI_UI.logTemplates.TEST_STATUS({test: {}}));
                          $('.testVersion', _self).html(FAPI_UI.logTemplates.TEST_VERSION({testVersion: ''}));
                          FAPI_UI.activeTooltip();
					  }


				   });

				   $('[data-publish]').click(function(evt) {
				       evt.preventDefault();

				       var publish = $(this).data('publish');

				       $.ajax({
				           type: 'POST',
				           url: '/api/plan/' + encodeURIComponent(planId) + '/publish',
				           contentType: 'application/json',
				           data: JSON.stringify({ publish: publish }),
				           success: function(data) {
				               // redirect to the published version or reload
				               window.location.assign('/plan-detail.html?plan=' + encodeURIComponent(planId) + (publish ? '&public=true' : ''));
				           },
				           error: function(jqxhr, status, error) {
				               FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
				                   code: jqxhr.status,
				                   error: error
				               });
				           }
				       });
				   });

                    //only for making an immutable plan mutable again
				   $('[data-immutable]').click(function(evt) {
				       evt.preventDefault();

				       $.ajax({
				           type: 'POST',
				           url: '/api/plan/' + encodeURIComponent(planId) + '/makemutable',
				           contentType: 'application/x-www-form-urlencoded',
				           success: function(data) {
				               // redirect to the published version or reload
				               window.location.assign('/plan-detail.html?plan=' + encodeURIComponent(planId));
				           },
				           error: function(jqxhr, status, error) {
				               FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
				                   code: jqxhr.status,
				                   error: error
				               });
				           }
				       });
				   });

				   $('#reRunTestModalBtn').click(function(evt) {
					   evt.preventDefault();
					   var testName = $('#reRunTestModalBtn').data('test-name');
					   var variant = $('#reRunTestModalBtn').data('variant');
					   runTest(testName, variant, planId);
				   });

			   },
               error: function(jqxhr, status, error) {
                   FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
                       code: jqxhr.status,
                       error: error
                   });
               }
		   })

	   }

	   function runTest(testName, testVariant, planId) {
		   var runTestUrl = '/api/runner/?test=' + encodeURIComponent(testName) + '&plan=' + encodeURIComponent(planId);

		   if (testVariant !== null && testVariant !== undefined) {
			   runTestUrl += '&variant=' + encodeURIComponent(JSON.stringify(testVariant));
		   }

		   FAPI_UI.showBusy('Creating a new test for ' + testName + '...');

		   $.ajax({
			   url: runTestUrl,
			   type: 'POST',
			   contentType: 'application/json',
			   success: function(testData, status) {
				   // we need to switch to the new window now
				   window.location.assign('/log-detail.html?log=' + encodeURIComponent(testData.id));
			   },
			   error: function(jqxhr, status, error) {
				   FAPI_UI.showError(jqxhr.responseJSON ? jqxhr.responseJSON : {
					   code: jqxhr.status,
					   error: error
				   });
			   }
		   });
	   }

       function showDialogError(containerId, error) {
            $('<div class="alert alert-danger">' +
               '<button type="button" class="close" data-dismiss="alert">' +
               '&times;</button>' + error + '</div>').appendTo('#' + containerId);
        }

       /**
        * Checks file inputs to make sure they're within max file size limits
        * @param filesToCheck array of file 'input' element IDs to check
        * @param maxFileSize max file size
        * @returns {number} -1 if all files are less than maxFileSize
        *                   else the return value is the nth element
        *                   in the list
        */
       function validateFileSizes(filesToCheck, maxFileSize) {
           for(var i = 0; i < filesToCheck.length; i++) {
               var file = $('#' + filesToCheck[i]);
               if(file[0].files && file[0].files.length > 0) {
                   if(file[0].files[0].size > maxFileSize) {
                       return i;
                   }
               }
           }
           return -1;
       }

       $('#certificationPackageForm').on('submit', certificationPackageFormOnSubmit);

        function certificationPackageFormOnSubmit(e){
            const filesToCheck = ["termsAndConditionsPdfBtn", "certificationOfConformancePdfBtn", "clientSideDataBtn"];
            const maxFileSize = 1024000;
            const fileNum = validateFileSizes(filesToCheck, maxFileSize);
            if( fileNum >= 0) {
                e.preventDefault();
                showDialogError('certificationPackageFormErrors', $('#' + filesToCheck[fileNum])[0].files[0].name + ' exceeded the maximum allowed size of ' + maxFileSize + ' bytes.');
	            return false;
            } else {
                $('#certificationPackageFormSubmitBtn').attr('disabled', 'disabled');
                $('#certificationPackageFormRefreshNotice').show();
                return true;
            }
        }


		$(document).ready(function() {
			var urlParams = new URLSearchParams(window.location.search);
			var planId = urlParams.get('plan');
			var public = Boolean(urlParams.get('public'));

			FAPI_UI.showBusy();

			FAPI_UI.loadPlanTemplates() // Load the templates
			.then(function() {
				return FAPI_UI.getUserInfo() // Then get the current user info
			}).then(function() {
				return getPlan(planId, public); // Only once the user is loaded, then render the plan info
			}).always(function() {
				FAPI_UI.activeTooltip();
				FAPI_UI.hideBusy();
			});

			var clipboard = new ClipboardJS('.btn-clipboard');
			clipboard.on('success', function(e) {
				console.log(e);
			});
			clipboard.on('error', function(e) {
				console.log(e);
			});

		});
	</script>


	<footer class="pageFooter">
		<div class="row">
			<span class="muted">Open Banking Brasil Functional Conformance Suite - Brought to you by Raidiam, with thanks to the OpenID Foundation<br /></span>
			<span class="muted"></span><a href="https://raidiam.com"><img src="/images/raidiam.png" width="285" height="32"></a></span>
		</div>
	</footer>

</body>

</html>
